globus_thread_once(3)

NAME
globus_thread_once - One-time execution

 - One-time execution.

SYNOPSIS

  Data Structures

union globus_thread_once_t
Thread once structure.

  Macros

#define GLOBUS_THREAD_ONCE_INIT
Thread once initializer value.

  Functions

int globus_thread_once (globus_thread_once_t *once, void(*init_routine)(void))
Execute a function one time.

Detailed Description

One-time execution.

The globus_thread_once_t provides a way for applications and libraries to execute some code exactly one time, independent of the number of threads which attempt to execute it. To use this, statically initialize a globus_thread_once_t control with the value GLOBUS_THREAD_ONCE_INIT, and pass a pointer to a function to execute once, along with the control, to globus_thread_once().

Function Documentation

  int globus_thread_once (globus_thread_once_t * once, void(* init_routine )(void))

Execute a function one time. The globus_thread_once() function will execute the function pointed to by its init_routine parameter one time for each unique globus_thread_once_t object passed to it, independent of the number of threads calling it. The once value must be a static value initialized to GLOBUS_THREAD_ONCE_INIT.

Parameters
    once A pointer to the value used to govern whether the function passed via the init_routine parameter has executed.
    init_routine Function to execute one time. It is called with no parameters.

Returns
    On success, globus_thread_once() guarantees that the function pointed to by init_routine has run, and that subsequent calls to globus_thread_once() with the same value of once will not execute that function, and returns GLOBUS_SUCCESS. If an error occurs, globus_thread_once() returns an implementation-specific non-zero error value.

Author

Generated automatically by Doxygen for globus_common from the source code.